<?php
/// CONFIGURATION
// inclus dans lib.php
	/**
 * Given an object containing all the necessary configuration data,
 * this function
 * will update an existing record.
 *
 * @param object $instance An object from the form in mod.html
 * @return boolean Success/Fail

 CREATE TABLE `mdl_referentiel` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(80) NOT NULL DEFAULT '',
  `description_instance` text NOT NULL,
  `label_domaine` varchar(80) NOT NULL DEFAULT '',
  `label_competence` varchar(80) NOT NULL DEFAULT '',
  `label_item` varchar(80) NOT NULL DEFAULT '',
  `date_instance` bigint(10) unsigned NOT NULL DEFAULT '0',
  `course` bigint(10) unsigned NOT NULL DEFAULT '0',
  `ref_referentiel` bigint(10) unsigned NOT NULL DEFAULT '0',
  `visible` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `config` varchar(255) NOT NULL,
  `config_impression` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Instance de referentiel de competence';



CREATE TABLE IF NOT EXISTS `mdl_referentiel_referentiel` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(80) NOT NULL DEFAULT '',
  `code_referentiel` varchar(20) NOT NULL DEFAULT '',
  `mail_auteur_referentiel` varchar(255) NOT NULL DEFAULT '',
  `cle_referentiel` varchar(255) NOT NULL DEFAULT '',
  `pass_referentiel` varchar(255) NOT NULL DEFAULT '',
  `description_referentiel` text NOT NULL,
  `url_referentiel` varchar(255) NOT NULL DEFAULT '',
  `seuil_certificat` double NOT NULL DEFAULT '0',
  `timemodified` bigint(10) unsigned NOT NULL DEFAULT '0',
  `nb_domaines` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `liste_codes_competence` text NOT NULL,
  `liste_empreintes_competence` text NOT NULL,
  `liste_poids_competence` text NOT NULL,
  `local` bigint(10) unsigned NOT NULL DEFAULT '0',
  `logo_referentiel` varchar(255) NOT NULL DEFAULT '',
  `config` varchar(255) NOT NULL DEFAULT 'scol:0;creref:0;selref:0;impcert:0;',
  `config_impression` varchar(255) NOT NULL DEFAULT 'refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Referentiel de competence' AUTO_INCREMENT=51 ;

 */


 // -----------------------------
function referentiel_affiche_config($str_config, $type='config'){
// item = 'scol', 'creref', 'selref', 'impcert', refcert, instcert, numetu, nometu, etabetu, ddnetu, lieuetu, adretu, pourcent, compdec, compval, referent, jurycert, comcert,
// 'scol:0;creref:0;selref:0;impcert:0;refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
// retourne une liste de selecteurs
// $type : config ou config_impression
global $CFG;
	$s='';
	if ($str_config==''){
		$str_config=referentiel_creer_configuration($type);
	}
	// DEBUG
	// echo "<br />DEBUG :: lib.php :: 3675 ::  $str_config\n";
	if ($str_config!=''){
		$tconfig=explode(';',$str_config);
		$n=count($tconfig);
		if ($n>0){
			$i=0;
			while ($i<$n){
				$tconfig[$i]=trim($tconfig[$i]);
				if ($tconfig[$i]!=''){
					list($cle, $val)=explode(':',$tconfig[$i]);
					$cle=trim($cle);
					$val=trim($val);
					if ($cle!=''){

						$s.=''.get_string($cle,'referentiel').' ';
						$str_conf=referentiel_associe_item_configuration($cle);
						// creer le parametre si necessaire
						if (!isset($CFG->$str_conf)){
							$CFG->$str_conf=0;
						}
						if ($CFG->$str_conf==2){
							$s.= ' (<i>'.$cle.'</i>) <b>'.get_string('config_verrouillee','referentiel').'</b>'."\n";
 						}
						elseif ($val==1){
							$s.=' (<i>'.$cle.'</i>) <b>'.get_string('yes')."</b>\n";
 						}
						else {
							$s.=' (<i>'.$cle.'</i>) <b>'.get_string('no')."</b>\n";
						}
						$s.='<br />'."\n";
					}
				}
				$i++;
			}
		}
	}
	return $s;
}

// -----------------------
function referentiel_is_author($userid, $referentiel_referentiel){
    // return true if userid is refrentiel_referentiel author
	return (!empty($referentiel_referentiel->mail_auteur_referentiel)
        && ($referentiel_referentiel->mail_auteur_referentiel==referentiel_get_user_mail($userid)));
}


// -----------------------
function referentiel_instance_get_referentiel($instanceid){
// retourne l'id du referentiel associé à une instance
    global $CFG;
    if ($instanceid){
		$instance=get_record_sql('SELECT ref_referentiel FROM '. $CFG->prefix . 'referentiel WHERE id='.$instanceid.' ');
		if ($instance){
            return $instance->ref_referentiel;
        }
    }
    return 0;
}

// -----------------------
function referentiel_global_can_write_or_import_ref($referentiel_referentiel_id) {
// examine en cascade la configuration au niveau du site, du referentiel
// verifier si autorisation de creation de referentiel au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->referentiel_creation_limitee)){
		$CFG->referentiel_creation_limitee=0;
	}

	if ($CFG->referentiel_creation_limitee!=2){
        if ($referentiel_referentiel_id){
            return (referentiel_ref_get_item_config('creref', $referentiel_referentiel_id, 'config')==0);
        }
    }
    return false;
}

// -----------------------
function referentiel_global_can_select_referentiel($referentiel_referentiel_id) {
// examine en cascade la configuration au niveau du site, du referentiel
// verifier si autorisation de selection d'un referentiel existant au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->referentiel_selection_autorisee)){
		$CFG->referentiel_selection_autorisee=0;
	}
	if ($CFG->referentiel_selection_autorisee!=2) {
        /// verifier valeur globale
        if ($referentiel_referentiel_id){
            return(referentiel_ref_get_item_config('selref', $referentiel_referentiel_id, 'config')==0);
        }
    }
    return false;
}

// -----------------------
function referentiel_global_can_print_referentiel($referentiel_referentiel_id) {
// examine en cascade la configuration au niveau du site, du referentiel
// verifier si autorisation d'impression d'un certificat au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->impression_referentiel_autorisee)){
		$CFG->impression_referentiel_autorisee=0;
	}
	if ($CFG->impression_referentiel_autorisee!=2) {
        /// verifier valeur globale
        if ($referentiel_referentiel_id){
            return(referentiel_ref_get_item_config('impcert', $referentiel_referentiel_id, 'config')==0);
        }
    }
    return false;
}


// -----------------------
function referentiel_site_can_write_or_import_referentiel($referentiel_instance_id) {
// examine en cascade la configuration au niveau du site, du referentiel, de l'instance
// verifier si autorisation de creation de referentiel au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->referentiel_creation_limitee)){
		$CFG->referentiel_creation_limitee=0;
	}

	if ($CFG->referentiel_creation_limitee!=2){
        /// verifier valeur globale
        $referentiel_referentiel_id=referentiel_instance_get_referentiel($referentiel_instance_id);
        if ($referentiel_referentiel_id){
            if (referentiel_ref_get_item_config('creref', $referentiel_referentiel_id, 'config')==0){
                /// retourner valeur locale
                return (referentiel_get_item_configuration('creref', $referentiel_instance_id, 'config')==0);
            }
        }
    }
    return false;
}

// -----------------------
function referentiel_site_can_select_referentiel($referentiel_instance_id) {
// examine en cascade la configuration au niveau du site, du referentiel, de l'instance
// verifier si autorisation de selection d'un referentiel existant au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->referentiel_selection_autorisee)){
		$CFG->referentiel_selection_autorisee=0;
	}
	if ($CFG->referentiel_selection_autorisee!=2) {
        /// verifier valeur globale
        $referentiel_referentiel_id=referentiel_instance_get_referentiel($referentiel_instance_id);
        if ($referentiel_referentiel_id){
            if (referentiel_ref_get_item_config('selref', $referentiel_referentiel_id, 'config')==0){
            	/// renvoyer valeur locale
                return (referentiel_get_item_configuration('selref', $referentiel_instance_id, 'config')==0);
            }
        }
    }
    return false;
}

// -----------------------
function referentiel_site_can_print_referentiel($referentiel_instance_id) {
// examine en cascade la configuration au niveau du site, du referentiel, de l'instance
// verifier si autorisation d'impression d'un certificat au niveau des cours
    global $CFG;
	// configuration
    if (!isset($CFG->impression_referentiel_autorisee)){
		$CFG->impression_referentiel_autorisee=0;
	}
	if ($CFG->impression_referentiel_autorisee!=2) {
        /// verifier valeur globale
        $referentiel_referentiel_id=referentiel_instance_get_referentiel($referentiel_instance_id);
        if ($referentiel_referentiel_id){
            if (referentiel_ref_get_item_config('impcert', $referentiel_referentiel_id, 'config')==0){
            	/// renvoyer valeur locale
                return (referentiel_get_item_configuration('impcert', $referentiel_instance_id, 'config')==0);
            }
        }
    }
    return false;
}

// -----------------------
function referentiel_associe_item_configuration($item){
// retourne le nom du parametre de configuration
		switch($item){
			case 'scol' :	return 'referentiel_scolarite_masquee'; break;
			case 'creref' :	return 'referentiel_creation_limitee'; break;
			case 'selref' :	return 'referentiel_selection_autorisee'; break;
			case 'impcert' : return 'referentiel_impression_autorisee'; break;
			case 'refcert' : return 'certificat_sel_referentiel'; break;
			case 'instcert' : return 'certificat_sel_referentiel_instance'; break;
			case 'numetu' : return 'certificat_sel_etudiant_numero'; break;
			case 'nometu' : return 'certificat_sel_etudiant_nom_prenom'; break;
			case 'etabetu' : return 'certificat_sel_etudiant_etablissement'; break;
			case 'ddnetu' : return 'certificat_sel_etudiant_ddn'; break;
			case 'lieuetu' : return 'certificat_sel_etudiant_lieu_naissance'; break;
			case 'adretu' : return 'certificat_sel_etudiant_adresse'; break;
			case 'detail' : return 'certificat_sel_certificat_detail'; break;
			case 'pourcent' : return 'certificat_sel_certificat_pourcent'; break;
			case 'compdec' : return 'certificat_sel_activite_competences'; break;
			case 'compval' : return 'certificat_sel_certificat_competences'; break;
			case 'nomreferent' : return 'certificat_sel_certificat_referents'; break;
			case 'jurycert' : return 'certificat_sel_decision_jury'; break;
			case 'comcert' : return 'certificat_sel_commentaire'; break;
		}
		return '';
}

// -----------------------
function referentiel_creer_configuration($type='config'){
// initialise le vecteur de configuration
global $CFG;
$s='';
	if ($type=='config'){
		// configuration
		if (isset($CFG->referentiel_scolarite_masquee)){
			$s.='scol:'.$CFG->referentiel_scolarite_masquee.';';
		}
		else{
			$s.='scol:0;';
		}
		if (isset($CFG->referentiel_creation_limitee)){
			$s.='creref:'.$CFG->referentiel_creation_limitee.';';
		}
		else{
			$s.='creref:0;';
		}
		if (isset($CFG->referentiel_selection_autorisee)){
			$s.='selref:'.$CFG->referentiel_selection_autorisee.';';
		}
		else{
			$s.='selref:0;';
		}
		if (isset($CFG->referentiel_impression_autorisee)){
			$s.='impcert:'.$CFG->referentiel_impression_autorisee.';';
		}
		else{
			$s.='impcert:0;';
		}
	}
	else{
		// impression certificat
		// instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;

		// impression certificat
		if (isset($CFG->certificat_sel_referentiel)){
			$s.='refcert:'.$CFG->certificat_sel_referentiel.';';
		}
		else{
			$s.='refcert:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_referentiel_instance)){
			$s.='instcert:'.$CFG->certificat_sel_referentiel_instance;
		}
		else{
			$s.='instcert:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_etudiant_numero)){
			$s.='numetu:'.$CFG->certificat_sel_etudiant_numero;
		}
		else{
			$s.='numetu:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_etudiant_nom_prenom)){
			$s.='nometu:'.$CFG->certificat_sel_etudiant_nom_prenom;
		}
		else{
			$s.='nometu:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_etudiant_etablissement)){
			$s.='etabetu:'.$CFG->certificat_sel_etudiant_etablissement;
		}
		else{
			$s.='etabetu:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_etudiant_ddn)){
			$s.='ddnetu:'.$CFG->certificat_sel_etudiant_ddn;
		}
		else{
			$s.='ddnetu:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_etudiant_lieu_naissance)){
			$s.='lieuetu:'.$CFG->certificat_sel_etudiant_lieu_naissance;
		}
		else{
			$s.='lieuetu:0;';
		}

				// impression certificat
		if (isset($CFG->certificat_sel_etudiant_adresse)){
			$s.='adretu:'.$CFG->certificat_sel_etudiant_adresse;
		}
		else{
			$s.='adretu:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_certificat_detail)){
			$s.='detail:'.$CFG->certificat_sel_certificat_detail;
		}
		else{
			$s.='detail:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_certificat_pourcent)){
			$s.='pourcent:'.$CFG->certificat_sel_certificat_pourcent;
		}
		else{
			$s.='pourcent:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_activite_competences)){
			$s.='compdec:'.$CFG->certificat_sel_activite_competences;
		}
		else{
			$s.='compdec:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_certificat_competences)){
			$s.='compval:'.$CFG->certificat_sel_certificat_competences;
		}
		else{
			$s.='compval:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_certificat_referents)){
			$s.='nomreferent:'.$CFG->certificat_sel_certificat_referents;
		}
		else{
			$s.='nomreferent:0;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_decision_jury)){
			$s.='jurycert:'.$CFG->certificat_sel_decision_jury;
		}
		else{
			$s.='jurycert:1;';
		}

		// impression certificat
		if (isset($CFG->certificat_sel_commentaire)){
			$s.='comcert:'.$CFG->certificat_sel_commentaire;
		}
		else{
			$s.='comcert:0;';
		}
	}
	return $s;
}


// ---------------------------------
function referentiel_global_set_vecteur_config($str_config, $referentiel_referentiel_id){
//  sauvegarde de la configuration globale
	$ok=false;
	if (!empty($referentiel_referentiel_id) && !empty($str_config)){
        $ok=set_field('referentiel_referentiel','config',$str_config,'id',$referentiel_referentiel_id);
	}
	return $ok;
}


// ---------------------------------
function referentiel_set_vecteur_configuration($str_config, $referentiel_instance_id){
//  sauvegarde de la configuration locale
	$ok=false;
	if (!empty($referentiel_instance_id) && !empty($str_config)){
		// DEBUG
		// echo "<br />DEBUG :: lib.php :: 3521 :: $str_config\n";
		// $referentiel_instance = get_record('referentiel', 'id', $referentiel_instance_id);
		// $referentiel_instance->config=$str_config;
		// DEBUG
		// print_object($referentiel_instance);
		// echo "<br />";
		// $ok=update_record("referentiel", $referentiel_instance);

        $ok=set_field('referentiel','config',$str_config,'id',$referentiel_instance_id);

	}
	return $ok;
}

// ---------------------------------
function referentiel_global_set_vecteur_config_imp($str_config, $referentiel_referentiel_id){
//  sauvegarde de la configuration d'impression globale
	$ok=false;
	if (!empty($referentiel_referentiel_id) && !empty($str_config)){
		$ok=set_field('referentiel_referentiel','config_impression',$str_config,'id',$referentiel_referentiel_id);
	}
	return $ok;
}

// ---------------------------------
function referentiel_set_vecteur_configuration_impression($str_config, $referentiel_instance_id){
//  sauvegarde de la configuration d'impression locale
	$ok=false;
	if (!empty($referentiel_instance_id) && !empty($str_config)){
		// DEBUG
		// echo "<br />DEBUG :: lib.php :: 3539 :: $str_config\n";
		// $referentiel_instance = get_record('referentiel', 'id', $referentiel_instance_id);
		// $referentiel_instance->config_impression=$str_config;

		// DEBUG
		// print_object($referentiel_instance);
		// echo "<br />";
		// $ok=update_record("referentiel", $referentiel_instance);
		$ok=set_field('referentiel','config_impression',$str_config,'id',$referentiel_instance_id);
	}
	return $ok;
}


// ---------------------------------
function referentiel_ref_set_option_imp_certificat($referentiel_referentiel_id, $form){
//  sauvegarde de la configuration d'impression globale
// $form : un formulaire de saisie
	$ok=false;
	if (!empty($referentiel_referentiel_id) && !empty($form)){
		$str_config=referentiel_initialise_configuration($form, 'config_impression');
		return referentiel_global_set_vecteur_config_imp($str_config, $referentiel_referentiel_id);
	}
	return $ok;
}

// ---------------------------------
function referentiel_set_option_impression_certificat($referentiel_instance_id, $form){
//  sauvegarde de la configuration d'impression locale
// $form : un formulaire de saisie
	$ok=false;
	if (!empty($referentiel_instance_id) && !empty($form)){
		$str_config=referentiel_initialise_configuration($form, 'config_impression');
		return referentiel_set_vecteur_configuration_impression($str_config, $referentiel_instance_id);
	}
	return $ok;
}

// ---------------------------------
function referentiel_initialise_configuration($form, $type='config'){
// initialise le vecteur de configuration en fonction des parametres saisis dans le formulaire
// item type config = 'scol', 'creref', 'selref', 'impcert',
// item type config_impression = 'refcert', 'instcert', 'numetu', nometu, etabetu, ddnetu, lieuetu, adretu, pourcent, compdec, compval, nomreferent, jurycert, comcert,
// Valeurs par defaut 'scol:0;creref:0;selref:0;impcert:0;
// Valeurs par defaut : refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;

$s='';
	if ($type=='config'){
		// affichage scolarite
		if (isset($form->scol)){
			$s.='scol:'.$form->scol.';';
		}
		else {
			$s.='scol:0;';
		}
		// creation referentiel
		if (isset($form->creref)){
			$s.='creref:'.$form->creref.';';
		}
		else{
			$s.='creref:0;';
		}
		// selection referentiel
		if (isset($form->selref)){
			$s.='selref:'.$form->selref.';';
		}
		else{
			$s.='selref:0;';
		}

		// impression certificat
		if (isset($form->impcert)){
			$s.='impcert:'.$form->impcert.';';
		}
		else{
			$s.='impcert:0;';
		}
	}
	else{

		//Valeurs par defaut : refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;

		// impression certificat
		if (isset($form->refcert)){
			$s.='refcert:'.$form->refcert.';';
		}
		else{
			$s.='refcert:1;';
		}

				// impression certificat
		if (isset($form->instcert)){
			$s.='instcert:'.$form->instcert.';';
		}
		else{
			$s.='instcert:0;';
		}

		// impression certificat
		if (isset($form->numetu)){
			$s.='numetu:'.$form->numetu.';';
		}
		else{
			$s.='numetu:1;';
		}


		// impression certificat
		if (isset($form->nometu)){
			$s.='nometu:'.$form->nometu.';';
		}
		else{
			$s.='nometu:1;';
		}

		// impression certificat
		if (isset($form->etabetu)){
			$s.='etabetu:'.$form->etabetu.';';
		}
		else{
			$s.='etabetu:0;';
		}

		// impression certificat
		if (isset($form->ddnetu)){
			$s.='ddnetu:'.$form->ddnetu.';';
		}
		else{
			$s.='ddnetu:0;';
		}


		// impression certificat
		if (isset($form->lieuetu)){
			$s.='lieuetu:'.$form->lieuetu.';';
		}
		else{
			$s.='lieuetu:0;';
		}

		// impression certificat
		if (isset($form->adretu)){
			$s.='adretu:'.$form->adretu.';';
		}
		else{
			$s.='adretu:0;';
		}

		// impression certificat
		if (isset($form->detail)){
			$s.='detail:'.$form->detail.';';
		}
		else{
			$s.='detail:0;';
		}

		// impression certificat
		if (isset($form->pourcent)){
			$s.='pourcent:'.$form->pourcent.';';
		}
		else{
			$s.='pourcent:0;';
		}

		// impression certificat
		if (isset($form->compdec)){
			$s.='compdec:'.$form->compdec.';';
		}
		else{
			$s.='compdec:0;';
		}

		// impression certificat
		if (isset($form->compval)){
			$s.='compval:'.$form->compval.';';
		}
		else{
			$s.='compval:1;';
		}

		// impression certificat
		if (isset($form->nomreferent)){
			$s.='nomreferent:'.$form->nomreferent.';';
		}
		else{
			$s.='nomreferent:0;';
		}

		// impression certificat
		if (isset($form->jurycert)){
			$s.='jurycert:'.$form->jurycert.';';
		}
		else{
			$s.='jurycert:1;';
		}

		// impression certificat
		if (isset($form->comcer)){
			$s.='comcert:'.$form->comcer.';';
		}
		else{
			$s.='comcert:0;';
		}
	}
	return ($s);
}

// -----------------------------
function referentiel_selection_configuration($str_config, $type='config'){
// item = 'scol', 'creref', 'selref', 'impcert', refcert, instcert, numetu, nometu, etabetu, ddnetu, lieuetu, adretu, pourcent, compdec, compval, referent, jurycert, comcert,
// 'scol:0;creref:0;selref:0;impcert:0;refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
// retourne une liste de selecteurs
// $type : config ou config_impression
global $CFG;
	$s='';
	if ($str_config==''){
		$str_config=referentiel_creer_configuration($type);
	}
	// DEBUG
	// echo "<br />DEBUG :: lib.php :: 3675 ::  $str_config\n";
	if ($str_config!=''){
		$tconfig=explode(';',$str_config);
		$n=count($tconfig);
		if ($n>0){
			$i=0;
			while ($i<$n){
				$tconfig[$i]=trim($tconfig[$i]);
				if ($tconfig[$i]!=''){
					list($cle, $val)=explode(':',$tconfig[$i]);
					$cle=trim($cle);
					$val=trim($val);
					if ($cle!=''){

						$s.=''.get_string($cle,'referentiel').' ';
						$str_conf=referentiel_associe_item_configuration($cle);
						// creer le parametre si necessaire
						if (!isset($CFG->$str_conf)){
							$CFG->$str_conf=0;
						}
						if ($CFG->$str_conf==2){
							$s.= '<input type="hidden" name="'.$cle.'" value="2" /> <b>'.get_string('config_verrouillee','referentiel').'</b>'."\n";
 						}
						elseif ($val==1){
							$s.=' <input type="radio" name="'.$cle.'" value="0" />'.get_string('no').'
 <input type="radio" name="'.$cle.'" value="1"  checked="checked" />'.get_string('yes')."\n";
 						}
						else {
							$s.=' <input type="radio" name="'.$cle.'" value="0" checked="checked" />'.get_string('no').'
 <input type="radio" name="'.$cle.'" value="1" />'.get_string('yes')."\n";
						}
						$s.='<br />'."\n";
					}
				}
				$i++;
			}
		}
	}
	$s.=' <input type="hidden" name="config" value="'.$str_config.'" />'."\n";
	return $s;
}


// ---------------------------------
function referentiel_ref_get_vecteur_config($ref_referentiel_referentiel) {
// retourne la valeur de configuration globale pour ce referentiel
global $CFG;
	if (isset($ref_referentiel_referentiel) && ($ref_referentiel_referentiel>0)){
		$config = new object();
		$config = get_record_sql('SELECT config FROM '. $CFG->prefix . 'referentiel_referentiel WHERE id='.$ref_referentiel_referentiel);
		if ($config){
			return($config->config);
		}
	}
	return '';
}


// ---------------------------------
function referentiel_get_vecteur_configuration($ref_instance_referentiel) {
// retourne la valeur de configuration locale pour cette instance de referentiel
global $CFG;
	if (isset($ref_instance_referentiel) && ($ref_instance_referentiel>0)){
		$config = new object();
		$config = get_record_sql('SELECT config FROM '. $CFG->prefix . 'referentiel WHERE id='.$ref_instance_referentiel);
		if ($config){
			return($config->config);
		}
	}
	return '';
}

// ---------------------------------
function referentiel_ref_get_vecteur_config_imp($ref_referentiel_referentiel) {
// retourne la valeur de configuration globale pour ce referentiel
global $CFG;
	if (isset($ref_referentiel_referentiel) && ($ref_referentiel_referentiel>0)){
		$config = new object();
		$config = get_record_sql('SELECT config_impression FROM '. $CFG->prefix . 'referentiel_referentiel WHERE id='.$ref_referentiel_referentiel);
		if ($config){
			return($config->config_impression);
		}
	}
	return '';
}


// ---------------------------------
function referentiel_get_vecteur_configuration_impression($ref_instance_referentiel) {
// retourne la valeur de configuration locale pour cette instance de referentiel
global $CFG;
	if (isset($ref_instance_referentiel) && ($ref_instance_referentiel>0)){
		$config = new object();
		$config = get_record_sql('SELECT config_impression FROM '. $CFG->prefix . 'referentiel WHERE id='.$ref_instance_referentiel);
		if ($config){
			return($config->config_impression);
		}
	}
	return '';
}

// ---------------------------------
function referentiel_ref_get_item_config($item, $ref_referentiel_referentiel, $type='config') {
// retourne la valeur de configuration globale pour l'item considere
// 'scol:0;creref:0;selref:0;impcert:0;refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
// type : config ou config_impression
global $CFG;
	if (isset($ref_referentiel_referentiel) && ($ref_referentiel_referentiel>0)){
		if ($type=='config'){
			$str_config = referentiel_ref_get_vecteur_config($ref_referentiel_referentiel);
		}
		else{
			$str_config = referentiel_ref_get_vecteur_config_imp($ref_referentiel_referentiel);
		}
		if ($str_config!=''){
			$tconfig=explode(';',$str_config);
			$n=count($tconfig);
			if ($n>0){
				$i=0;
				while ($i<$n){
					$tconfig[$i]=trim($tconfig[$i]);
					if ($tconfig[$i]!=''){
						list($cle, $val)=explode(':',$tconfig[$i]);
						$cle=trim($cle);
						$val=trim($val);

						if ($cle==$item){
							return ($val);
						}
					}
					$i++;
				}
			}
		}
	}
	return 0;
}

// ---------------------------------
function referentiel_get_item_configuration($item, $ref_instance_referentiel, $type='config') {
// retourne la valeur de configuration locale pour l'item considere
// 'scol:0;creref:0;selref:0;impcert:0;refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
// type : config ou config_impression
global $CFG;
	if (isset($ref_instance_referentiel) && ($ref_instance_referentiel>0)){
		if ($type=='config'){
			$str_config = referentiel_get_vecteur_configuration($ref_instance_referentiel);
		}
		else{
			$str_config = referentiel_get_vecteur_configuration_impression($ref_instance_referentiel);
		}
		if ($str_config!=''){
			$tconfig=explode(';',$str_config);
			$n=count($tconfig);
			if ($n>0){
				$i=0;
				while ($i<$n){
					$tconfig[$i]=trim($tconfig[$i]);
					if ($tconfig[$i]!=''){
						list($cle, $val)=explode(':',$tconfig[$i]);
						$cle=trim($cle);
						$val=trim($val);

						if ($cle==$item){
							return ($val);
						}
					}
					$i++;
				}
			}
		}
	}
	return 0;
}


// -----------------------
function referentiel_associe_item_param_configuration($param, $item, $value){
// retourne un objet intitialisé
		switch($item){
		// type config
			case 'scol' :	$param->referentiel_scolarite_masquee=$value; break;
			case 'creref' :	$param->referentiel_creation_limitee=$value; break;
			case 'selref' :	$param->referentiel_selection_autorisee=$value; break;
			case 'impcert' : $param->referentiel_impression_autorisee=$value; break;
		// type config_impression
			case 'refcert' : $param->certificat_sel_referentiel=$value; break;
			case 'instcert' : $param->certificat_sel_referentiel_instance=$value; break;
			case 'numetu' : $param->certificat_sel_etudiant_numero=$value; break;
			case 'nometu' : $param->certificat_sel_etudiant_nom_prenom=$value; break;
			case 'etabetu' : $param->certificat_sel_etudiant_etablissement=$value; break;
			case 'ddnetu' : $param->certificat_sel_etudiant_ddn=$value; break;
			case 'lieuetu' : $param->certificat_sel_etudiant_lieu_naissance=$value; break;
			case 'adretu' : $param->certificat_sel_etudiant_adresse=$value; break;
			case 'detail' : $param->certificat_sel_certificat_detail=$value; break;
			case 'pourcent' : $param->certificat_sel_certificat_pourcent=$value; break;
			case 'compdec' : $param->certificat_sel_activite_competences=$value; break;
			case 'compval' : $param->certificat_sel_certificat_competences=$value; break;
			case 'nomreferent' : $param->certificat_sel_certificat_referents=$value; break;
			case 'jurycert' : $param->certificat_sel_decision_jury=$value; break;
			case 'comcert' : $param->certificat_sel_commentaire=$value; break;
		}
		return $param;
}


// ---------------------------------
function referentiel_ref_set_param_config($param, $ref_referentiel_referentiel, $type='config'){
// enregistre la configuration globale
// type config : 'scol:0;creref:0;selref:0;impcert:0;'
// type config_impression : 'refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
//
global $CFG;
$str_config='';
	if (!empty($param) && isset($ref_referentiel_referentiel) && ($ref_referentiel_referentiel>0)){
		if ($type=='config'){
			if (!empty($param->referentiel_scolarite_masquee) && ($param->referentiel_scolarite_masquee==1)) $str_config.='scol:1;'; else $str_config.='scol:0;';
			if (!empty($param->referentiel_creation_limitee) && ($param->referentiel_creation_limitee==1)) $str_config.='creref:1;'; else $str_config.='creref:0;';
			if (!empty($param->referentiel_selection_autorisee) && ($param->referentiel_selection_autorisee==1)) $str_config.='selref:1;'; else $str_config.='selref:0;';
			if (!empty($param->referentiel_impression_autorisee) && ($param->referentiel_impression_autorisee==1)) $str_config.='impcert:1;'; else $str_config.='impcert:0;';
			if ($str_config!='') {
				referentiel_global_set_vecteur_config($str_config, $ref_referentiel_referentiel);
			}
		}
		else{
		// type config_impression
			if (!empty($param->certificat_sel_referentiel) && ($param->certificat_sel_referentiel==1)) $str_config.='refcert:1;';  else $str_config.='refcert:0;';
			if (!empty($param->certificat_sel_referentiel_instance) && ($param->certificat_sel_referentiel_instance==1)) $str_config.='instcert:1;'; else $str_config.='instcert:0;';
			if (!empty($param->certificat_sel_etudiant_numero) && ($param->certificat_sel_etudiant_numero==1)) $str_config.='numetu:1;'; else $str_config.='numetu:0;';
			if (!empty($param->certificat_sel_etudiant_nom_prenom) && ($param->certificat_sel_etudiant_nom_prenom==1)) $str_config.='nometu:1;'; else $str_config.='nometu:0;';
			if (!empty($param->certificat_sel_etudiant_etablissement) && ($param->certificat_sel_etudiant_etablissement==1)) $str_config.='etabetu:1;'; else $str_config.='etabetu:0;';
			if (!empty($param->certificat_sel_etudiant_ddn) && ($param->certificat_sel_etudiant_ddn==1)) $str_config.='ddnetu:1;'; else $str_config.='ddnetu:0;';
			if (!empty($param->certificat_sel_etudiant_lieu_naissance) && ($param->certificat_sel_etudiant_lieu_naissance==1)) $str_config.='lieuetu:1;'; else $str_config.='lieuetu:0;';
			if (!empty($param->certificat_sel_etudiant_adresse) && ($param->certificat_sel_etudiant_adresse==1)) $str_config.='adretu:1'; else $str_config.='adretu:0';
			if (!empty($param->certificat_sel_certificat_detail) && ($param->certificat_sel_certificat_detail==1)) $str_config.='detail:1;'; else $str_config.='detail:0;';
			if (!empty($param->certificat_sel_certificat_pourcent) && ($param->certificat_sel_certificat_pourcent==1)) $str_config.='pourcent:1;'; else $str_config.='pourcent:0;';
			if (!empty($param->certificat_sel_activite_competences) && ($param->certificat_sel_activite_competences==1)) $str_config.='compdec:1;'; else $str_config.='compdec:0;';
			if (!empty($param->certificat_sel_certificat_competences) && ($param->certificat_sel_certificat_competences==1)) $str_config.='compval:1;'; else $str_config.='compval:0;';
			if (!empty($param->certificat_sel_certificat_referents) && ($param->certificat_sel_certificat_referents==1)) $str_config.='nomreferent:1;'; else $str_config.='nomreferent:0;';
			if (!empty($param->certificat_sel_decision_jury) && ($param->certificat_sel_decision_jury==1)) $str_config.='jurycert:1;'; else $str_config.='jurycert:0;';
			if (!empty($param->certificat_sel_commentaire) && ($param->certificat_sel_commentaire==1)) $str_config.='comcert:1;'; else $str_config.='comcert:0;';
			if ($str_config!='') {
				referentiel_global_set_vecteur_config_imp($str_config, $ref_referentiel_referentiel);
			}
		}
		// DEBUG
		// echo "<br />DEBUG :: lib_config.php :: 815 :: $str_config\n";
	}
}


// ---------------------------------
function referentiel_set_param_configuration($param, $ref_instance_referentiel, $type='config'){
// enregistre la configuration locale
// type config : 'scol:0;creref:0;selref:0;impcert:0;'
// type config_impression : 'refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
//
global $CFG;
$str_config='';
	if (!empty($param) && isset($ref_instance_referentiel) && ($ref_instance_referentiel>0)){
		if ($type=='config'){
			if (!empty($param->referentiel_scolarite_masquee) && ($param->referentiel_scolarite_masquee==1)) $str_config.='scol:1;'; else $str_config.='scol:0;';
			if (!empty($param->referentiel_creation_limitee) && ($param->referentiel_creation_limitee==1)) $str_config.='creref:1;'; else $str_config.='creref:0;';
			if (!empty($param->referentiel_selection_autorisee) && ($param->referentiel_selection_autorisee==1)) $str_config.='selref:1;'; else $str_config.='selref:0;';
			if (!empty($param->referentiel_impression_autorisee) && ($param->referentiel_impression_autorisee==1)) $str_config.='impcert:1;'; else $str_config.='impcert:0;';
			if ($str_config!='') {
				referentiel_set_vecteur_configuration($str_config, $ref_instance_referentiel);
			}
		}
		else{
		// type config_impression
			if (!empty($param->certificat_sel_referentiel) && ($param->certificat_sel_referentiel==1)) $str_config.='refcert:1;';  else $str_config.='refcert:0;';
			if (!empty($param->certificat_sel_referentiel_instance) && ($param->certificat_sel_referentiel_instance==1)) $str_config.='instcert:1;'; else $str_config.='instcert:0;';
			if (!empty($param->certificat_sel_etudiant_numero) && ($param->certificat_sel_etudiant_numero==1)) $str_config.='numetu:1;'; else $str_config.='numetu:0;';
			if (!empty($param->certificat_sel_etudiant_nom_prenom) && ($param->certificat_sel_etudiant_nom_prenom==1)) $str_config.='nometu:1;'; else $str_config.='nometu:0;';
			if (!empty($param->certificat_sel_etudiant_etablissement) && ($param->certificat_sel_etudiant_etablissement==1)) $str_config.='etabetu:1;'; else $str_config.='etabetu:0;';
			if (!empty($param->certificat_sel_etudiant_ddn) && ($param->certificat_sel_etudiant_ddn==1)) $str_config.='ddnetu:1;'; else $str_config.='ddnetu:0;';
			if (!empty($param->certificat_sel_etudiant_lieu_naissance) && ($param->certificat_sel_etudiant_lieu_naissance==1)) $str_config.='lieuetu:1;'; else $str_config.='lieuetu:0;';
			if (!empty($param->certificat_sel_etudiant_adresse) && ($param->certificat_sel_etudiant_adresse==1)) $str_config.='adretu:1'; else $str_config.='adretu:0';
			if (!empty($param->certificat_sel_certificat_detail) && ($param->certificat_sel_certificat_detail==1)) $str_config.='detail:1;'; else $str_config.='detail:0;';
			if (!empty($param->certificat_sel_certificat_pourcent) && ($param->certificat_sel_certificat_pourcent==1)) $str_config.='pourcent:1;'; else $str_config.='pourcent:0;';
			if (!empty($param->certificat_sel_activite_competences) && ($param->certificat_sel_activite_competences==1)) $str_config.='compdec:1;'; else $str_config.='compdec:0;';
			if (!empty($param->certificat_sel_certificat_competences) && ($param->certificat_sel_certificat_competences==1)) $str_config.='compval:1;'; else $str_config.='compval:0;';
			if (!empty($param->certificat_sel_certificat_referents) && ($param->certificat_sel_certificat_referents==1)) $str_config.='nomreferent:1;'; else $str_config.='nomreferent:0;';
			if (!empty($param->certificat_sel_decision_jury) && ($param->certificat_sel_decision_jury==1)) $str_config.='jurycert:1;'; else $str_config.='jurycert:0;';
			if (!empty($param->certificat_sel_commentaire) && ($param->certificat_sel_commentaire==1)) $str_config.='comcert:1;'; else $str_config.='comcert:0;';
			if ($str_config!='') {
				referentiel_set_vecteur_configuration_impression($str_config, $ref_instance_referentiel);
			}
		}
		// DEBUG
		// echo "<br />DEBUG :: lib.php :: 3922 :: $str_config\n";
	}
}

// ---------------------------------
function referentiel_ref_get_param_config($ref_referentiel_referentiel, $type='config') {

// retourne la valeur de configuration globale sous forme d'un objet
// type config : 'scol:0;creref:0;selref:0;impcert:0;'
// type config_impression : 'refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
//
global $CFG;
$param = new Object();
	if (isset($ref_referentiel_referentiel) && ($ref_referentiel_referentiel>0)){
		if ($type=='config'){
			$str_config = referentiel_ref_get_vecteur_config($ref_referentiel_referentiel);
		}
		else{
			$str_config = referentiel_ref_get_vecteur_config_imp($ref_referentiel_referentiel);
		}
		if ($str_config!=''){
			$tconfig=explode(';',$str_config);
			$n=count($tconfig);
			if ($n>0){
				$i=0;
				while ($i<$n){
					$tconfig[$i]=trim($tconfig[$i]);
					if ($tconfig[$i]!=''){
						list($cle, $val)=explode(':',$tconfig[$i]);
						$cle=trim($cle);
						$val=trim($val);
						$param=referentiel_associe_item_param_configuration($param, $cle, $val);
					}
					$i++;
				}
			}
		}
	}

	return $param;
}

// ---------------------------------
function referentiel_get_param_configuration($ref_instance_referentiel, $type='config') {
// retourne la valeur de configuration locale sous forme d'un objet
// type config : 'scol:0;creref:0;selref:0;impcert:0;'
// type config_impression : 'refcert:1;instcert:0;numetu:1;nometu:1;etabetu:0;ddnetu:0;lieuetu:0;adretu:0;detail:1;pourcent:0;compdec:0;compval:1;nomreferent:0;jurycert:1;comcert:0;'
//
global $CFG;
$param = new Object();
	if (isset($ref_instance_referentiel) && ($ref_instance_referentiel>0)){
		if ($type=='config'){
			$str_config = referentiel_get_vecteur_configuration($ref_instance_referentiel);
		}
		else{
			$str_config = referentiel_get_vecteur_configuration_impression($ref_instance_referentiel);
		}
		if ($str_config!=''){
			$tconfig=explode(';',$str_config);
			$n=count($tconfig);
			if ($n>0){
				$i=0;
				while ($i<$n){
					$tconfig[$i]=trim($tconfig[$i]);
					if ($tconfig[$i]!=''){
						list($cle, $val)=explode(':',$tconfig[$i]);
						$cle=trim($cle);
						$val=trim($val);
						$param=referentiel_associe_item_param_configuration($param, $cle, $val);
					}
					$i++;
				}
			}
		}
	}

	return $param;
}

?>
