<?php

// $Id:  lib.php,v 1.0 2008/04/29 00:00:00 jfruitet Exp $
///////////////////////////////////////////////////////////////////////////
//                                                                       //
// NOTICE OF COPYRIGHT                                                   //
//                                                                       //
// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
//          http://moodle.org                                            //
//                                                                       //
// Copyright (C) 2005 Martin Dougiamas  http://dougiamas.com             //
//                                                                       //
// This program is free software; you can redistribute it and/or modify  //
// it under the terms of the GNU General Public License as published by  //
// the Free Software Foundation; either version 2 of the License, or     //
// (at your option) any later version.                                   //
//                                                                       //
// This program is distributed in the hope that it will be useful,       //
// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
// GNU General Public License for more details:                          //
//                                                                       //
//          http://www.gnu.org/copyleft/gpl.html                         //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

/**
 * Library of functions and constants for module referentiel
 * 
 * @author jfruitet
 * @version $Id: lib.php,v 1.4 2006/08/28 16:41:20 mark-nielsen Exp $
 * @version $Id: lib.php,v 1.0 2008/04/29 00:00:00 jfruitet Exp $
 * @package referentiel
 **/
/*
DROP TABLE IF EXISTS prefix_referentiel_task`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_task` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_task` varchar(80) NOT NULL DEFAULT '',
  `description_task` text NOT NULL,
  `competences_task` text NOT NULL,
  `criteres_evaluation` text NOT NULL,
  `ref_instance` bigint(10) unsigned NOT NULL DEFAULT '0',
  `ref_referentiel` bigint(10) unsigned NOT NULL DEFAULT '0',
  `ref_course` bigint(10) unsigned NOT NULL DEFAULT '0',
  `auteurid` bigint(10) unsigned NOT NULL,
  `date_creation` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_modif` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_debut` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_fin` bigint(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='task' AUTO_INCREMENT=1 ;

--
-- Structure de la table `mdl_referentiel_consigne`
--

DROP TABLE IF EXISTS `mdl_referentiel_consigne`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_consigne` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_consigne` varchar(20) NOT NULL DEFAULT '',
  `description_consigne` text NOT NULL,
  `url_consigne` varchar(255) NOT NULL DEFAULT '',
  `ref_task` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='consigne' AUTO_INCREMENT=1 ;

--
-- Structure de la table `mdl_referentiel_a_user_task`
--

DROP TABLE IF EXISTS `mdl_referentiel_a_user_task`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_a_user_task` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `ref_user` bigint(10) unsigned NOT NULL,
  `ref_task` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='user_select_task' AUTO_INCREMENT=1 ;

*/

// Quelques fonctions regroupes dans lib.php



/**
 * Given an task id,
 * this function will permanently delete the task instance
 * and any consigne that depends on it.
 *
 * @param object $id
 * @return boolean Success/Failure
 **/

 // -----------------------
function referentiel_delete_task_and_activities($id) {
// suppression task + consignes associes + liens vers activite et user + activites dues a la tache
$ok_task=false;
	if (isset($id) && ($id>0)){
		if ($task = get_record("referentiel_task", "id", $id)) {
	   		// Delete any dependent records here
			if ($r_a_users_tasks = get_records("referentiel_a_user_task", "ref_task", $id)) {
				// DEBUG
				// echo "<br />            \n";
				// print_object($r_a_users_tasks);
				// echo "<br />suppression des activites\n";
				foreach ($r_a_users_tasks as $r_a_user_task){
					// suppression de l'activite
					referentiel_delete_activity_record($r_a_user_task->ref_activite);
				}
			}
            $ok_task=referentiel_delete_task_record($id);
		}
	}
    return $ok_task;
}

// -----------------------
function referentiel_task_isowner($id){
global $USER;
	if (isset($id) && ($id>0)){
		$record=get_record("referentiel_task", "id", "$id");
		// DEBUG
		// echo "<br >USERID : $USER->id ; OWNER : $record->userid\n";
		return ($USER->id == $record->auteurid);
	}
	else {
		return false;
	} 
} 



/**
 * Given a form, 
 * this function will permanently delete the task instance 
 * and any consigne that depends on it. 
 *
 * @param object $form
 * @return boolean Success/Failure
 **/

 // -----------------------
function referentiel_delete_task($form) {
// suppression task + consigne
$ok_task=false;
$ok_consigne=false;
    // DEBUG
	// echo "<br />";
	// print_object($form);
    // echo "<br />";
	if (isset($form->action) && ($form->action=="modifier_task")){
		// suppression d'une task et des consignes associes
		if (isset($form->task_id) && ($form->task_id>0)){
			$ok_task=referentiel_delete_task_record($form->task_id);
			// mise a zero du certificat associe a cette personne pour ce referentiel 
			// referentiel_certificat_user_invalider($form->userid, $form->ref_referentiel);
			// referentiel_regenere_certificat_user($form->userid, $form->ref_referentiel);
		}
	}
	else if (isset($form->action) && ($form->action=="modifier_consigne")){
		// suppression d'un consigne
		if (isset($form->consigne_id) && ($form->consigne_id>0)){
			$ok_consigne=referentiel_delete_consigne_record($form->consigne_id);
		}
	}
	
    return $ok_task or $ok_consigne;
}


/**
 * Given an object containing all the necessary referentiel, 
 * (defined by the form in mod.html) this function 
 * will create a new instance and return the id number 
 * of the new instance.
 *
 * @param object $instance An object from the form in mod.html
 * @return int The id of the newly inserted referentiel record
 **/
 /*
CREATE TABLE IF NOT EXISTS `mdl_referentiel_task` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_task` varchar(80) NOT NULL DEFAULT '',
  `description_task` text NOT NULL,
  `competences_task` text NOT NULL,
  `criteres_evaluation` text NOT NULL,
  `ref_instance` bigint(10) unsigned NOT NULL DEFAULT '0',
  `ref_referentiel` bigint(10) unsigned NOT NULL DEFAULT '0',
  `ref_course` bigint(10) unsigned NOT NULL DEFAULT '0',
  `auteurid` bigint(10) unsigned NOT NULL,
  `date_creation` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_modif` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_debut` bigint(10) unsigned NOT NULL DEFAULT '0',
  `date_fin` bigint(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='task' AUTO_INCREMENT=1 ;
 */

 // -----------------------
function referentiel_add_task($form) {
// creation task + consigne
global $USER;
    // DEBUG
    // echo "DEBUG : ADD task CALLED : lib.php : ligne 1033";
	// print_object($form);
    // echo "<br />";
	// referentiel
	$task = new object();
	$task->type_task=($form->type_task);
	$task->description_task=($form->description_task);
	if (isset($form->code_item)){
  	$task->competences_task=reference_conversion_code_2_liste_competence('/', $form->code_item);
	}
	else{
    $task->competences_task='';
  }
  $task->criteres_evaluation=($form->criteres_evaluation);
	$task->ref_instance=$form->instance;
	$task->ref_referentiel=$form->ref_referentiel;
	$task->ref_course=$form->course;
	$task->auteurid=$USER->id;		
	$task->date_creation=time();
	$task->date_modif=time();
  $task->cle_souscription=($form->cle_souscription);
  $task->souscription_libre=($form->souscription_libre);
  if (isset($form->tache_masquee)) 
    $task->tache_masquee=$form->tache_masquee;
  else 
    $task->tache_masquee=0; 

    $task->mailed=1;  // MODIF JF 2010/10/05
    if (isset($form->mailnow)){
        $task->mailnow=$form->mailnow;
        if ($form->mailnow=='1'){ // renvoyer
            $task->mailed=0;   // annuler envoi precedent
        }
    }
    else{
      $task->mailnow=0;
    }

	// DEBUG
	// echo "<br>DEBUG :: lib_task.php :: 252 :: DATE DEBUT: ".$form->date_debut."\n";
	// echo "<br>DEBUG :: lib_task.php :: 252 :: DATE FIN: ".$form->date_fin."\n";
	list($date,$heure)=explode(' ',$form->date_debut);
	list($h,$i)=explode(':',$heure);
	if (!$h) $h=0;
	if (!$i) $i=0;
	list($d,$m,$y)=explode('/',$date);
	$task->date_debut=mktime($h,$i,0,$m,$d,$y);
	// echo "<br>DEBUG :: lib_task.php :: 27 :: $d,$m,$y $h,$i--- ".$task->date_debut."\n";

	list($date,$heure)=explode(' ',$form->date_fin);
	list($h,$i)=explode(':',$heure);
	if (!$h) $h=0;
	if (!$i) $i=0;
	list($d,$m,$y)=explode('/',$date);
	$task->date_fin=mktime($h,$i,0,$m,$d,$y);
	//echo "<br>DEBUG :: lib_task.php :: 342 :: $d,$m,$y $h,$i--- ".$task->date_fin."\n";	
		
	    // DEBUG
		// print_object($task);
	    // echo "<br />";
	
	$task_id= insert_record("referentiel_task", $task);
		
    // echo "task ID / $task_id<br />";
	if 	(isset($task_id) && ($task_id>0)
			&& 
			(	(isset($form->url_consigne) && !empty($form->url_consigne))
				|| 
				(isset($form->description_consigne) && !empty($form->description_consigne))
			)
	){
	/*
	DROP TABLE IF EXISTS `mdl_referentiel_consigne`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_consigne` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_consigne` varchar(20) NOT NULL DEFAULT '',
  `description_consigne` text NOT NULL,
  `url_consigne` varchar(255) NOT NULL DEFAULT '',
  `ref_task` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='consigne' AUTO_INCREMENT=1 ;
	*/
		$consigne = new object();
		$consigne->url_consigne=$form->url_consigne;
		$consigne->type_consigne=$form->type_consigne;
		$consigne->description_consigne=$form->description_consigne;
		$consigne->ref_task=$task_id;
		if (isset($form->cible_consigne)){
			$consigne->cible_consigne=$form->cible_consigne;
   		}
		else{
			$consigne->cible_consigne=1;
		}
		if (isset($form->etiquette_consigne)){
			$consigne->etiquette_consigne=$form->etiquette_consigne;
   		}
		else{
			$consigne->etiquette_consigne='';
		}

	   	// DEBUG
		// print_object($consigne);
    	// echo "<br />";
		
		$consigne_id = insert_record("referentiel_consigne", $consigne);
    	// echo "consigne ID / $consigne_id<br />";
	}
    return $task_id;
}


// -----------------------
function referentiel_mask_task($id, $masque){
  if ($id){
    $record=get_record("referentiel_task", "id", $id);
    if ($record){
      if ($masque){
        $record->tache_masquee=1;    
      }
      else{
        $record->tache_masquee=0;
      }
      $record->type_task=addslashes($record->type_task);
      $record->description_task=addslashes($record->description_task);
      $record->criteres_evaluation=addslashes($record->criteres_evaluation);
      return update_record("referentiel_task", $record);
    }
  }
  return false; 
}

// -----------------------
function referentiel_update_task($form) {
// MAJ task + consigne;
// 19/01/2010 : la reference de l'auteur n'est pas actualise.
global $USER;
$ok=true;
    // DEBUG
	// echo "<br />UPDATE task<br />\n";
	// print_object($form);
    // echo "<br />";
	
	if (isset($form->action) && ($form->action=="modifier_task")){
		// task
		$task = new object();
		$task->id=($form->task_id);
		$task->type_task=($form->type_task);
		$task->description_task=($form->description_task);
		$task->competences_task=reference_conversion_code_2_liste_competence('/', $form->code_item);
		$task->criteres_evaluation=($form->criteres_evaluation);
		$task->ref_instance=$form->instance;
		$task->ref_referentiel=$form->ref_referentiel;
		$task->ref_course=$form->course;
		if (empty($form->auteurid)){
            $task->auteurid=$USER->id;
        }
		$task->date_creation=$form->date_creation;
		$task->date_modif=time();
        $task->cle_souscription=($form->cle_souscription);
        $task->souscription_libre=$form->souscription_libre;
		if (isset($form->tache_masquee))
            $task->tache_masquee=$form->tache_masquee;
        else
            $task->tache_masquee=0;

        // MODIF JF 2010/02/11
        if (isset($form->mailnow)){
            $task->mailnow=$form->mailnow;
            if ($form->mailnow=='1'){ // renvoyer
                $task->mailed=0;   // annuler envoi precedent
            }
        }
        else{
            $task->mailnow=0;
        }

        /*
        $task->date_debut=mktime($form->debut_heure, $form->debut_mois, $form->debut_jour, $form->debut_annee);
        $task->date_fin=mktime($form->fin_heure, $form->fin_mois, $form->fin_jour, $form->fin_annee);
        */
        // DEBUG
        // echo "<br>DEBUG :: lib_task.php :: 252 :: DATE DEBUT: ".$form->date_debut."\n";
        // echo "<br>DEBUG :: lib_task.php :: 252 :: DATE FIN: ".$form->date_fin."\n";
        list($date,$heure)=explode(' ',$form->date_debut);
        list($h,$i)=explode(':',$heure);
        if (!$h) $h=0;
        if (!$i) $i=0;
        list($d,$m,$y)=explode('/',$date);
        $task->date_debut=mktime($h,$i,0,$m,$d,$y);
        // echo "<br>DEBUG :: lib_task.php :: 27 :: $d,$m,$y $h,$i--- ".$task->date_debut."\n";

        list($date,$heure)=explode(' ',$form->date_fin);
        list($h,$i)=explode(':',$heure);
        if (!$h) $h=0;
        if (!$i) $i=0;
        list($d,$m,$y)=explode('/',$date);
        $task->date_fin=mktime($h,$i,0,$m,$d,$y);
        //echo "<br>DEBUG :: lib_task.php :: 342 :: $d,$m,$y $h,$i--- ".$task->date_fin."\n";
		
	    // DEBUG
		// print_object($task);
	    // echo "<br />";
		$ok = $ok && update_record("referentiel_task", $task);
		// exit;
	    // echo "DEBUG :: lib_task.php :: 350 :: task ID : $task->id<br />";
	}
	else if (isset($form->action) && ($form->action=="modifier_consigne")){
		$consigne = new object();
		$consigne->id=$form->consigne_id;
		$consigne->url_consigne=($form->url_consigne);
		$consigne->type_consigne=($form->type_consigne);
		$consigne->description_consigne=($form->description_consigne);
		$consigne->ref_task=$form->ref_task;
		if (isset($form->cible_consigne)){
			$consigne->cible_consigne=$form->cible_consigne;
   		}
		else{
			$consigne->cible_consigne=1;
		}
		if (isset($form->etiquette_consigne)){
			$consigne->etiquette_consigne=$form->etiquette_consigne;
   		}
		else{
			$consigne->etiquette_consigne='';
		}
		
   		// DEBUG
		// print_object($consigne);
    	// echo "<br />";
		$ok= $ok && update_record("referentiel_consigne", $consigne);
		// exit;
	}
	else if (isset($form->action) && ($form->action=="creer_consigne")){
		$consigne = new object();
		$consigne->url_consigne=($form->url_consigne);
		$consigne->type_consigne=($form->type_consigne);
		$consigne->description_consigne=($form->description_consigne);
		$consigne->ref_task=$form->ref_task;
		if (isset($form->cible_consigne)){
			$consigne->cible_consigne=$form->cible_consigne;
   		}
		else{
			$consigne->cible_consigne=1;
		}
		if (isset($form->etiquette_consigne)){
			$consigne->etiquette_consigne=$form->etiquette_consigne;
   		}
		else{
			$consigne->etiquette_consigne='';
		}
		
   		// DEBUG
		// print_object($consigne);
    	// echo "<br />";
		$ok = insert_record("referentiel_consigne", $consigne);
    	// echo "consigne ID / $ok<br />";
		// exit;
	}
    return $ok;
}

/**
 * Given a course and a time, this module should find recent task 
 * that has occurred in referentiel and print it out. 
 * Return true if there was output, or false is there was none. 
 *
 * @uses $CFG
 * @return boolean
 * @todo Finish this function
 **/
 // -----------------------
function referentiel_print_recent_task($course, $isteacher, $timestart) {
    global $CFG;

    return false;  //  True if anything was printed, otherwise false 
}

// -----------------------
function referentiel_update_consigne($form) {
// MAJ consigne;
    // DEBUG
	// echo "<br />UPDATE ACTIVITY<br />\n";
	// print_object($form);
    // echo "<br />";
	if (isset($form->consigne_id) && $form->consigne_id
		&&
		isset($form->ref_task) && $form->ref_task){
		$consigne = new object();
		$consigne->id=$form->consigne_id;
		$consigne->url_consigne=($form->url_consigne);
		$consigne->type_consigne=($form->type_consigne);
		$consigne->description_consigne=($form->description_consigne);
		$consigne->ref_task=$form->ref_task;
		if (isset($form->cible_consigne)){
			$consigne->cible_consigne=$form->cible_consigne;
   		}
		else{
			$consigne->cible_consigne=1;
		}
		if (isset($form->etiquette_consigne)){
			$consigne->etiquette_consigne=$form->etiquette_consigne;
   		}
		else{
			$consigne->etiquette_consigne='';
		}
		
   		// DEBUG
		// print_object($consigne);
    	// echo "<br />";
		return update_record("referentiel_consigne", $consigne);
	}
	return false;
}

// -----------------------
function referentiel_add_consigne($form) {
// MAJ consigne;
	$id_consigne=0;
	if (isset($form->ref_task)){
		$consigne = new object();
		$consigne->url_consigne=$form->url_consigne;
		$consigne->type_consigne=$form->type_consigne;
		$consigne->description_consigne=$form->description_consigne;
		$consigne->ref_task=$form->ref_task;
		if (isset($form->cible_consigne)){
			$consigne->cible_consigne=$form->cible_consigne;
   		}
		else{
			$consigne->cible_consigne=1;
		}
		if (isset($form->etiquette_consigne)){
			$consigne->etiquette_consigne=$form->etiquette_consigne;
   		}
		else{
			$consigne->etiquette_consigne='';
		}
		
   		// DEBUG
		// print_object($consigne);
    	// echo "<br />";
		$id_consigne = insert_record("referentiel_consigne", $consigne);
    	// echo "consigne ID / $ok<br />";
		// exit;
	}
    return $id_consigne;
}

// -----------------------
function referentiel_delete_all_associations_users_to_one_task($ref_task) {
// supprime toutes les associations pour une tache donnee
	$ok_association=true;
	if (isset($ref_task) && ($ref_task>O)){
		$a_records = get_records("referentiel_a_user_task", "ref_task", $ref_task);
		if ($a_records){
			foreach ($a_records as $a_record){
				// suppression
				$ok_association =$ok_association && referentiel_delete_a_user_task_record($a_record->id);
			}
		}
	}
    return $ok_association;
}

// -----------------------
function referentiel_delete_all_associations_tasks_to_one_user($ref_user) {
// supprime toutes les associations pour un user donne
/*
			DROP TABLE IF EXISTS `mdl_referentiel_a_user_task`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_a_user_task` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `ref_user` bigint(10) unsigned NOT NULL,
  `ref_task` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='user_select_task' AUTO_INCREMENT=1 ;
*/
	$ok_association=true;
	if (isset($ref_user) && ($ref_user>O)){
		$a_records = get_records("referentiel_a_user_task", "ref_user", $ref_user);
		if ($a_records){
			foreach ($a_records as $a_record){
				// suppression
				$ok_association =$ok_association && referentiel_delete_a_user_task_record($a_record->id);
			}
		}
	}
    return $ok_association;
}

// -----------------------
function referentiel_get_all_tasks_user($ref_user, $course_id, $referentiel_instance_id) {
// retourne un tableau d'objets taches pour un user donne
/*
			DROP TABLE IF EXISTS `mdl_referentiel_a_user_task`;
CREATE TABLE IF NOT EXISTS `mdl_referentiel_a_user_task` (
  `id` bigint(10) unsigned NOT NULL AUTO_INCREMENT,
  `ref_user` bigint(10) unsigned NOT NULL,
  `ref_task` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='user_select_task' AUTO_INCREMENT=1 ;
*/
global $CFG;
	$t_records=array();
	if (isset($referentiel_instance_id) && ($referentiel_instance_id>0)
		&& isset($course_id) && ($course_id>0)){
		if (isset($ref_user) && ($ref_user>0)){
			$a_records = get_records("referentiel_a_user_task", "ref_user", $ref_user);
			if ($a_records){
				foreach ($a_records as $a_record){
					$t_records[] = get_record_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_task 
 WHERE ref_instance='.$referentiel_instance_id. ' 
 AND ref_course='.$course_id.' AND id='.$a_record->ref_task.'  
 ORDER BY date_debut DESC, date_fin DESC, auteurid ASC ');
 				}
			}
		}
	}
    return $t_records;
}

// -----------------------
function referentiel_user_tache_souscrite($ref_user, $ref_task) {
// retourne vrai si cet utilisateur a souscrit  cette tache
		if ($ref_user && $ref_task){
			$a_record = get_record("referentiel_a_user_task", "ref_user", $ref_user, "ref_task", $ref_task);
			if ($a_record){
				return true;
			}
		}
    return false;
}

// -----------------------
function referentiel_get_all_tasks($course_id, $referentiel_instance_id){
global $CFG;
	$t_records=array();
	if (isset($referentiel_instance_id) && ($referentiel_instance_id>0)
		&& isset($course_id) && ($course_id>0)){
		$t_records = get_records_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_task 
 WHERE ref_instance='.$referentiel_instance_id. ' 
 AND ref_course='.$course_id.' 
 ORDER BY date_debut DESC, date_fin DESC, auteurid ASC ');
	}
    return $t_records;
}

// -----------------------
function referentiel_get_task($task_id, $auteur_id=0){
global $CFG;
	if (isset($task_id) && ($task_id>0)){
		if ($auteur_id>0){
			$t_record = get_record_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_task WHERE id='.$task_id.' AND auteurid='.$auteur_id);		
		}
		else {
			$t_record = get_record_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_task WHERE id='.$task_id);
		}
	}
    return $t_record;
}

// -----------------------
function referentiel_closed_task($task_id){
global $CFG;
	if (isset($task_id) && ($task_id>0)){
		if ($t_record = get_record_sql('SELECT date_fin FROM '. $CFG->prefix . 'referentiel_task WHERE id='.$task_id)){
			return ($t_record->date_fin<time());
		}
	}
    return false;
}



/**
 * This function returns record document from table referentiel_document
 *
 * @param id ref_task
 * @return objects
 * @todo Finish documenting this function
 **/
 // -----------------------
function referentiel_get_consignes($task_id){
global $CFG;
	if (isset($task_id) && ($task_id>0)){
		return get_records_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_consigne WHERE ref_task='.$task_id.' ORDER BY id ASC ');
	}
	else 
		return 0; 
}

// -----------------------
function referentiel_association_user_task($ref_user, $ref_task, $referent_id=0) {
// associe une tache  un utilisateur
//  cree l'activite a partir de l'association
global $CFG;
global $USER;
	// DEBUG
	// echo '<br />DEBUG :: lib_task.php :: 559 :: User : '.$ref_user.' Tache : '.$ref_task."\n";

	$activite_id=0;
	if ($ref_task && $ref_user){
		// verifier si association existe
		$sql1='SELECT * FROM '. $CFG->prefix . 'referentiel_a_user_task  WHERE ref_user='.$ref_user. ' AND ref_task='.$ref_task;
		// echo '<br />DEBUG :: lib_task.php :: 565 :: SQL: '.$sql1."\n";
		$record_association= get_record_sql($sql1);
 		
		if (!$record_association){
			// inexistant
			// Recuperer les info de la tache
			$t_record = get_record_sql('SELECT * FROM '. $CFG->prefix . 'referentiel_task WHERE id='.$ref_task);
			if ($t_record){
				// Creer l'activite
		 	   	// DEBUG
			    // echo "DEBUG : ADD ACTIVITY CALLED : lib_task.php : ligne 578";
				$activite = new object();
				$activite->type_activite='['.get_string('task','referentiel').' '.$ref_task.'] '.addslashes($t_record->type_task);
				$activite->competences_activite=addslashes($t_record->competences_task);
				$activite->description_activite='['.get_string('consigne_task','referentiel').' (<i>'.referentiel_get_user_info($t_record->auteurid).'</i>) : '.addslashes($t_record->description_task).']';
				$activite->commentaire_activite=addslashes($t_record->criteres_evaluation);
				$activite->ref_instance=$t_record->ref_instance;
				$activite->ref_referentiel=$t_record->ref_referentiel;
				$activite->ref_course=$t_record->ref_course;
				$activite->date_creation=time();
				$activite->date_modif=time();
				$activite->approved=0;
				$activite->userid=$ref_user;
				if (empty($referent_id)){
          $activite->teacherid=$t_record->auteurid;
				}
        else{
          $activite->teacherid=$referent_id;
        }
        $activite->ref_task=$ref_task;
				
    			// DEBUG
    			// echo "<br />DEBUG :: lib_task.php : 592 : APRES CREATION\n";	
				// print_object($activite);
    			// echo "<br />";
				$activite_id= insert_record("referentiel_activite", $activite);
				if ($activite_id){
					// echo "Activite ID : $activite_id<br />";
					// mise a zero du certificat associe a cette personne pour ce referentiel 
					referentiel_certificat_user_invalider($activite->userid, $activite->ref_referentiel);
					referentiel_regenere_certificat_user($activite->userid, $activite->ref_referentiel);
					$record_association = new object();
					$record_association->ref_user=$ref_user;
					$record_association->ref_task=$ref_task;
					$record_association->ref_activite=$activite_id;
					$record_association->date_selection=time();
   					// DEBUG
					//print_object($record_association);
    				//echo "<br />";
					$id_a = insert_record("referentiel_a_user_task", $record_association);
    				//echo "association ID : $id_a<br />";
					//exit;
				}
			}
		}
	}
  return $activite_id;
}

// -----------------------
function referentiel_validation_activite_task($ref_task, $select='') {
// Effectue la validation des activits souscrites a la tache
global $CFG;
global $USER;
	// DEBUG
	// echo '<br />DEBUG :: lib_task.php :: 669 :: Tache : '.$ref_task."<br />Selection :".$select."\n";
	if ($ref_task>0){
		$info_valideur=referentiel_get_user_info($USER->id);
		// verifier si association existe
		$sql1='SELECT * FROM '. $CFG->prefix . 'referentiel_a_user_task  WHERE ref_task='.$ref_task;
		if (!empty($select)){
          $sql1.=' '.$select.' ';
    }
		// echo '<br />DEBUG :: lib_task.php :: 677 :: SQL: '.$sql1."\n";
		$records_association= get_records_sql($sql1);
 		
		if ($records_association){
			foreach ($records_association as $record_association){
 				if ($record_association){
					$ref_user=$record_association->ref_user;
					$ref_activite=$record_association->ref_activite;
   					// DEBUG
					//print_object($record_association);
    				//echo "<br />";
					// Approuver l'activite
					// recuperer l'info sur l'activite
			    if ($approverecord = get_record('referentiel_activite', 'id', $ref_activite)) {
						$approverecord->approved = 1;
						$approverecord->teacherid=$USER->id;
						$approverecord->date_modif=time();
						$approverecord->type_activite=addslashes($approverecord->type_activite);
						$approverecord->description_activite=addslashes($approverecord->description_activite);
						$approverecord->commentaire_activite=addslashes($approverecord->commentaire_activite."\n".get_string('approved_task_by','referentiel')." ".$info_valideur." (".date("d/m/Y H:i").")\n");
						// DEBUG
						// print_r($approverecord);
						// echo "<br />\n";
						
			      if (update_record('referentiel_activite', $approverecord)) {
							// regeneration du certificat associe a cette personne pour ce referentiel 
							referentiel_certificat_user_invalider($approverecord->userid, $approverecord->ref_referentiel);
							referentiel_regenere_certificat_user($approverecord->userid, $approverecord->ref_referentiel);
            }
				  }
        }
		  }
	 }
  }
}

// -----------------------
function referentiel_get_activites_task($ref_task) {
// Retourne la liste des activits lies  une tache
global $CFG;
	// DEBUG
	// echo '<br />DEBUG :: lib_task.php :: 685 :: Tache : '.$ref_task."\n";
	if ($ref_task>0){
		// verifier si association existe
		$sql='SELECT * FROM '. $CFG->prefix . 'referentiel_activite  WHERE ref_task='.$ref_task;
		// echo '<br />DEBUG :: lib_task.php :: 736 :: SQL: '.$sql1."\n";
		return get_records_sql($sql);
 	}
	return false;
}


// -----------------------
function referentiel_get_liste_codes_competence_tache($ref_task) {
global $CFG;
	// DEBUG
	// echo '<br />DEBUG :: lib_task.php :: 652 :: Tache : '.$ref_task."\n";
	if ($ref_task>0){
		// verifier si association existe
		$sql='SELECT competences_task FROM '. $CFG->prefix . 'referentiel_task  WHERE id='.$ref_task;
		// echo '<br />DEBUG :: lib_task.php :: 656 :: SQL: '.$sql."\n";
		$rtask=get_record_sql($sql);
		if ($rtask){
			return $rtask->competences_task;
		}
 	}
	return '';
}

?>